
/*  A Bison parser, made from parse.y with Bison version GNU Bison version 1.22
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	LOR	258
#define	LAND	259
#define	EQU	260
#define	NEQ	261
#define	LE	262
#define	GE	263
#define	LSH	264
#define	RSH	265
#define	LSB	266
#define	MSB	267
#define	ALIGN	268
#define	ASCII	269
#define	ASCIZ	270
#define	BEGNN	271
#define	BSS	272
#define	BYTE	273
#define	CODE	274
#define	DATA	275
#define	DBYT	276
#define	DCI	277
#define	ELSE	278
#define	END	279
#define	ENDIF	280
#define	ENDM	281
#define	IF	282
#define	EXPAND	283
#define	FLOAT	284
#define	GLOBAL	285
#define	HIBIT	286
#define	MACRO	287
#define	LONG	288
#define	SPACE	289
#define	WORD	290
#define	ZERO	291
#define	IMPORT	292
#define	ZIMPORT	293
#define	INTLIT	294
#define	FLOATLIT	295
#define	CHARLIT	296
#define	TEXTLIT	297
#define	LABEL	298
#define	IDENT	299

#line 12 "parse.y"


#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include "util.h"
#include "error.h"
#include "names.h"
#include "obj.h"
#include "asm.h"

/* For error reporting */

	#define	yyerror		uerror

/* Generic constant expression evaluation */

	#define	UnaryOp(a,b,OPR)													\
	{																			\
		if (a.type == iUnknown)													\
			b.type = iUnknown;													\
		else if (a.type != iSegRel || a.u.segrel.segment != AbsSegment)			\
			uerror("illegal expression");										\
		else																	\
		{																		\
			b.type = iSegRel;													\
			b.u.segrel.segment = AbsSegment;									\
			b.u.segrel.offset = OPR b.u.segrel.offset;							\
		}																		\
	}

	#define	BinaryOp(a,b,c,OPR)													\
	{																			\
		if (a.type == iUnknown || b.type == iUnknown)							\
			c.type = iUnknown;													\
		else if (a.type != iSegRel || a.u.segrel.segment != AbsSegment			\
			  || b.type != iSegRel || b.u.segrel.segment != AbsSegment)			\
			uerror("illegal expression");										\
		else																	\
		{																		\
			c.type = iSegRel;													\
			c.u.segrel.segment = AbsSegment;									\
			c.u.segrel.offset = a.u.segrel.offset OPR b.u.segrel.offset;		\
		}																		\
	}


#line 87 "parse.y"
typedef union
	{
		unsigned		id;				/* Identifier */
		int				intval;			/* Integer literal */
		double			floatval;		/* Floating point literal */
		char			charval;		/* Character literal */
		struct TValue	textval;		/* String literal */
		struct IValue	ivalue;			/* Ivalue */
		struct List		ivlist;			/* List of ivalues */
		struct List		idlist;			/* List of identifiers */
		struct List		flist;			/* List of floats */
	} YYSTYPE;

#ifndef YYLTYPE
typedef
  struct yyltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  yyltype;

#define YYLTYPE yyltype
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		144
#define	YYFLAG		-32768
#define	YYNTBASE	66

#define YYTRANSLATE(x) ((unsigned)(x) <= 299 ? yytranslate[x] : 78)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    60,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,    24,     2,     2,     2,    23,    10,     2,    62,
    63,    21,    19,     3,    20,     2,    22,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     5,     2,    13,
    61,    14,     4,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    64,     2,    65,     9,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     8,     2,    25,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     6,     7,    11,
    12,    15,    16,    17,    18,    26,    27,    28,    29,    30,
    31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
    41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
    51,    52,    53,    54,    55,    56,    57,    58,    59
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     5,     8,    10,    13,    17,    19,    20,    22,
    26,    30,    33,    38,    43,    50,    57,    60,    62,    64,
    66,    69,    72,    75,    78,    81,    84,    87,    90,    93,
    96,    99,   102,   105,   108,   111,   113,   115,   117,   119,
   121,   123,   125,   127,   131,   133,   137,   139,   143,   145,
   149,   155,   157,   159,   163,   167,   170,   173,   176,   179,
   183,   187,   191,   195,   199,   203,   207,   211,   215,   219,
   223,   227,   231,   235,   239,   243,   245,   247,   249,   251,
   254,   257,   259
};

static const short yyrhs[] = {    67,
     0,    66,    67,     0,    68,    60,     0,    70,     0,    69,
    70,     0,    58,    61,    74,     0,    58,     0,     0,    59,
     0,    59,    26,    74,     0,    59,    27,    74,     0,    59,
    74,     0,    59,    62,    74,    63,     0,    59,    74,     3,
    59,     0,    59,    62,    74,    63,     3,    59,     0,    59,
    62,    74,     3,    59,    63,     0,    28,    75,     0,    34,
     0,    35,     0,    32,     0,    46,    75,     0,    43,    75,
     0,    29,    77,     0,    30,    77,     0,    37,    77,     0,
    33,    72,     0,    50,    72,     0,    36,    72,     0,    48,
    72,     0,    49,    75,     0,    51,    75,     0,    44,    73,
     0,    52,    71,     0,    53,    71,     0,    45,    71,     0,
    31,     0,    39,     0,    47,     0,    41,     0,    42,     0,
    38,     0,    40,     0,    59,     0,    59,     3,    71,     0,
    74,     0,    74,     3,    72,     0,    76,     0,    76,     3,
    73,     0,    75,     0,    64,    74,    65,     0,    75,     4,
    74,     5,    74,     0,    21,     0,    59,     0,    74,    19,
    74,     0,    74,    20,    74,     0,    19,    74,     0,    20,
    74,     0,    24,    74,     0,    25,    74,     0,    74,    21,
    74,     0,    74,    22,    74,     0,    74,    23,    74,     0,
    74,    17,    74,     0,    74,    18,    74,     0,    74,     7,
    74,     0,    74,     6,    74,     0,    74,    10,    74,     0,
    74,     9,    74,     0,    74,     8,    74,     0,    74,    11,
    74,     0,    74,    12,    74,     0,    74,    13,    74,     0,
    74,    15,    74,     0,    74,    14,    74,     0,    74,    16,
    74,     0,    54,     0,    56,     0,    74,     0,    55,     0,
    19,    55,     0,    20,    55,     0,    57,     0,    57,    57,
     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   120,   122,   125,   135,   137,   138,   204,   250,   255,   259,
   263,   267,   271,   275,   290,   297,   307,   312,   313,   314,
   318,   319,   323,   324,   325,   329,   330,   331,   332,   336,
   345,   357,   383,   413,   446,   472,   473,   474,   475,   476,
   477,   478,   483,   489,   498,   504,   513,   519,   528,   535,
   539,   543,   549,   618,   668,   716,   717,   718,   719,   720,
   721,   722,   723,   724,   725,   726,   727,   728,   729,   730,
   731,   732,   733,   734,   735,   738,   740,   743,   750,   751,
   752,   755,   757
};

static const char * const yytname[] = {   "$","error","$illegal.","','","'?'",
"':'","LOR","LAND","'|'","'^'","'&'","EQU","NEQ","'<'","'>'","LE","GE","LSH",
"RSH","'+'","'-'","'*'","'/'","'%'","'!'","'~'","LSB","MSB","ALIGN","ASCII",
"ASCIZ","BEGNN","BSS","BYTE","CODE","DATA","DBYT","DCI","ELSE","END","ENDIF",
"ENDM","IF","EXPAND","FLOAT","GLOBAL","HIBIT","MACRO","LONG","SPACE","WORD",
"ZERO","IMPORT","ZIMPORT","INTLIT","FLOATLIT","CHARLIT","TEXTLIT","LABEL","IDENT",
"'\\n'","'='","'('","')'","'['","']'","program","complete_line","line","local_label",
"unlabeled_line","id_list","iv_list","f_list","i_value","const_int","f_value",
"t_value",""
};
#endif

static const short yyr1[] = {     0,
    66,    66,    67,    68,    68,    68,    69,    70,    70,    70,
    70,    70,    70,    70,    70,    70,    70,    70,    70,    70,
    70,    70,    70,    70,    70,    70,    70,    70,    70,    70,
    70,    70,    70,    70,    70,    70,    70,    70,    70,    70,
    70,    70,    71,    71,    72,    72,    73,    73,    74,    74,
    74,    74,    74,    74,    74,    74,    74,    74,    74,    74,
    74,    74,    74,    74,    74,    74,    74,    74,    74,    74,
    74,    74,    74,    74,    74,    75,    75,    76,    76,    76,
    76,    77,    77
};

static const short yyr2[] = {     0,
     1,     2,     2,     1,     2,     3,     1,     0,     1,     3,
     3,     2,     4,     4,     6,     6,     2,     1,     1,     1,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     1,     1,     1,     1,
     1,     1,     1,     3,     1,     3,     1,     3,     1,     3,
     5,     1,     1,     3,     3,     2,     2,     2,     2,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     1,     1,     1,     1,     2,
     2,     1,     2
};

static const short yydefact[] = {     8,
     0,     0,     0,    36,    20,     0,    18,    19,     0,     0,
    41,    37,    42,    39,    40,     0,     0,     0,     0,    38,
     0,     0,     0,     0,     0,     0,     7,     9,     8,     1,
     0,     8,     4,    76,    77,    17,    82,    23,    24,     0,
     0,    52,     0,     0,    53,     0,    26,    45,    49,    28,
    25,    22,     0,     0,    79,    32,    78,    47,    43,    35,
    21,    29,    30,    27,    31,    33,    34,     0,     0,     0,
     0,    12,     2,     3,     5,    83,    56,    57,    58,    59,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    80,    81,     0,     0,     6,    10,    11,     0,     0,
    50,    46,    66,    65,    69,    68,    67,    70,    71,    72,
    74,    73,    75,    63,    64,    54,    55,    60,    61,    62,
     0,    48,    44,     0,    13,    14,     0,     0,     0,    51,
    16,    15,     0,     0
};

static const short yydefgoto[] = {    29,
    30,    31,    32,    33,    60,    47,    56,    48,    49,    58,
    38
};

static const short yypact[] = {   228,
   -47,   -45,   -45,-32768,-32768,   229,-32768,-32768,   229,   -45,
-32768,-32768,-32768,-32768,-32768,   -47,   174,   -49,   -47,-32768,
   229,   -47,   229,   -47,   -49,   -49,   -48,   163,   121,-32768,
   -46,   266,-32768,-32768,-32768,-32768,   -42,-32768,-32768,   229,
   229,-32768,   229,   229,-32768,   229,-32768,   320,    21,-32768,
-32768,-32768,   181,   188,-32768,-32768,   378,    28,    30,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,   229,   229,   229,
   229,   341,-32768,-32768,-32768,-32768,   -19,   -19,-32768,-32768,
   116,   229,   229,   229,   229,   229,   229,   229,   229,   229,
   229,   229,   229,   229,   229,   229,   229,   229,   229,   229,
   229,-32768,-32768,   174,   -49,   378,   378,   378,    85,   -25,
-32768,-32768,   395,   411,   426,   440,   453,    42,    42,    24,
    24,    24,    24,    -1,    -1,   -19,   -19,-32768,-32768,-32768,
   360,-32768,-32768,   -11,    36,-32768,   229,   -14,    -9,   378,
-32768,-32768,    86,-32768
};

static const short yypgoto[] = {-32768,
    61,-32768,-32768,    77,   -20,     7,     6,   -17,    16,-32768,
    -2
};


#define	YYLAST		476


static const short yytable[] = {    57,
    39,    98,    99,   100,    66,    67,    34,    51,    35,    59,
    72,    37,    68,    74,    76,    50,    36,    96,    97,    98,
    99,   100,    77,    78,   101,    79,    80,    62,    81,    64,
   104,    52,   105,   136,    61,    77,    78,    63,   139,    65,
    94,    95,    96,    97,    98,    99,   100,   138,   141,   142,
   106,   107,   108,   109,    90,    91,    92,    93,    94,    95,
    96,    97,    98,    99,   100,   113,   114,   115,   116,   117,
   118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
   128,   129,   130,   131,   133,   144,    57,   134,   112,    73,
    83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
    93,    94,    95,    96,    97,    98,    99,   100,    75,   132,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   140,
   143,    83,    84,    85,    86,    87,    88,    89,    90,    91,
    92,    93,    94,    95,    96,    97,    98,    99,   100,     0,
     0,     0,     0,     0,     0,     0,     0,   135,     1,     2,
     3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
    13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
    23,    24,    25,    26,     0,     0,     0,     0,    27,    28,
   111,    40,    41,    42,     0,     0,    43,    44,    69,    70,
     0,     0,    53,    54,    42,     0,     0,    43,    44,    40,
    41,    42,     0,     0,    43,    44,    40,    41,    42,     0,
     0,    43,    44,     0,     0,     0,    34,     0,    35,     0,
     0,    45,     0,     0,    71,     0,    46,    34,    55,    35,
     0,     0,    45,     0,    34,   102,    35,    46,     0,    45,
     0,    34,   103,    35,    46,     0,    45,    40,    41,    42,
     0,    46,    43,    44,     0,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,     0,    34,     0,    35,    27,    28,    45,     0,     0,
     0,     0,    46,     1,     2,     3,     4,     5,     6,     7,
     8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
    18,    19,    20,    21,    22,    23,    24,    25,    26,     0,
     0,     0,    82,     0,    28,    83,    84,    85,    86,    87,
    88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
    98,    99,   100,   110,     0,     0,    83,    84,    85,    86,
    87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
    97,    98,    99,   100,   137,    83,    84,    85,    86,    87,
    88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
    98,    99,   100,    83,    84,    85,    86,    87,    88,    89,
    90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
   100,    84,    85,    86,    87,    88,    89,    90,    91,    92,
    93,    94,    95,    96,    97,    98,    99,   100,    85,    86,
    87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
    97,    98,    99,   100,    86,    87,    88,    89,    90,    91,
    92,    93,    94,    95,    96,    97,    98,    99,   100,    87,
    88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
    98,    99,   100,    88,    89,    90,    91,    92,    93,    94,
    95,    96,    97,    98,    99,   100
};

static const short yycheck[] = {    17,
     3,    21,    22,    23,    25,    26,    54,    10,    56,    59,
    28,    57,    61,    60,    57,     9,     1,    19,    20,    21,
    22,    23,    40,    41,     4,    43,    44,    21,    46,    23,
     3,    16,     3,    59,    19,    53,    54,    22,     3,    24,
    17,    18,    19,    20,    21,    22,    23,    59,    63,    59,
    68,    69,    70,    71,    13,    14,    15,    16,    17,    18,
    19,    20,    21,    22,    23,    83,    84,    85,    86,    87,
    88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
    98,    99,   100,   101,   105,     0,   104,     3,    82,    29,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    32,   104,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   137,
     0,     6,     7,     8,     9,    10,    11,    12,    13,    14,
    15,    16,    17,    18,    19,    20,    21,    22,    23,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    63,    28,    29,
    30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
    40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
    50,    51,    52,    53,    -1,    -1,    -1,    -1,    58,    59,
    65,    19,    20,    21,    -1,    -1,    24,    25,    26,    27,
    -1,    -1,    19,    20,    21,    -1,    -1,    24,    25,    19,
    20,    21,    -1,    -1,    24,    25,    19,    20,    21,    -1,
    -1,    24,    25,    -1,    -1,    -1,    54,    -1,    56,    -1,
    -1,    59,    -1,    -1,    62,    -1,    64,    54,    55,    56,
    -1,    -1,    59,    -1,    54,    55,    56,    64,    -1,    59,
    -1,    54,    55,    56,    64,    -1,    59,    19,    20,    21,
    -1,    64,    24,    25,    -1,    28,    29,    30,    31,    32,
    33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
    43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
    53,    -1,    54,    -1,    56,    58,    59,    59,    -1,    -1,
    -1,    -1,    64,    28,    29,    30,    31,    32,    33,    34,
    35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
    45,    46,    47,    48,    49,    50,    51,    52,    53,    -1,
    -1,    -1,     3,    -1,    59,     6,     7,     8,     9,    10,
    11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
    21,    22,    23,     3,    -1,    -1,     6,     7,     8,     9,
    10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
    20,    21,    22,    23,     5,     6,     7,     8,     9,    10,
    11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
    21,    22,    23,     6,     7,     8,     9,    10,    11,    12,
    13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
    23,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,     8,     9,
    10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
    20,    21,    22,    23,     9,    10,    11,    12,    13,    14,
    15,    16,    17,    18,    19,    20,    21,    22,    23,    10,
    11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
    21,    22,    23,    11,    12,    13,    14,    15,    16,    17,
    18,    19,    20,    21,    22,    23
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/lib/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Bob Corbett and Richard Stallman

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */


#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#define YYLEX		yylex(&yylval, &yylloc)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_bcopy(FROM,TO,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (from, to, count)
     char *from;
     char *to;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (char *from, char *to, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 184 "/usr/lib/bison.simple"
int
yyparse()
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_bcopy ((char *)yyss1, (char *)yyss, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_bcopy ((char *)yyvs1, (char *)yyvs, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_bcopy ((char *)yyls1, (char *)yyls, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 3:
#line 127 "parse.y"
{
		if (gListFile && gPass == 2)
			ListLine(gListFile);
		gLineNumber++;
		gLocLabel = FALSE;
	;
    break;}
case 6:
#line 139 "parse.y"
{
		Symbol	sym = GetSym(yyvsp[-2].id);

	/* Check stuff */

		switch (gPass)
		{
			case 1:
				if (sym)
					uerror("symbol \"%s\" defined previously: "
						"file \"%s\", line %d", Name(gNames, yyvsp[-2].id),
						Name(gNames, sym->file), sym->line);
				else
				{
					sym = DefineSym(yyvsp[-2].id);
					sym->file = NameID(gNames, gFileName);
					sym->line = gLineNumber;
				}
				break;
			case 2:
				if (!sym)
					cerror("lost symbol \"%s\"", Name(gNames, sym->id));
				break;
			default:
				assert(0);
		}

	/* Set value */

		switch (yyvsp[0].ivalue.type)
		{
			case iSegRel:
				sym->type = sSegRel;
				sym->u.segrel = yyvsp[0].ivalue.u.segrel;
				sym->valid = TRUE;
				break;
			case iSymOff:
				sym->type = sSymOff;
				sym->u.symoff = yyvsp[0].ivalue.u.symoff;
				sym->valid = TRUE;
				break;
			case iUnknown:
				if (gPass == 1)
				{
					sym->type = sSegRel;
					sym->u.segrel.segment = AbsSegment;
					sym->u.segrel.offset = 0;
				}
				else
					uerror("can't resolve this expression");
				break;
			default:
				assert(0);
		}

	/* Debugging */

		if (gDebug)
		{
			fprintf(stderr, "--> DEFINED: ");
			ShowSym(stderr, sym);
		}
	;
    break;}
case 7:
#line 206 "parse.y"
{
		Symbol	sym = GetSym(yyvsp[0].id);

		gLocLabel = TRUE;
		switch (gPass)
		{
			case 1:
				if (sym)
					uerror("symbol \"%s\" defined previously: "
						"file \"%s\", line %d", Name(gNames, yyvsp[0].id),
						Name(gNames, sym->file), sym->line);
				else
				{
					sym = DefineSym(yyvsp[0].id);
					sym->file = NameID(gNames, gFileName);
					sym->line = gLineNumber;
					sym->type = sSegRel;
					sym->u.segrel.segment = gSegment;
					sym->u.segrel.offset = gAddress[gSegment];
					sym->valid = TRUE;
					if (gDebug)
					{
						fprintf(stderr, "--> DEFINED: ");
						ShowSym(stderr, sym);
					}
				}
				break;

			case 2:
				if (!sym)
					cerror("symbol not found");
				if (!sym->valid || sym->type != sSegRel)
					cerror("symbol inconsistency");
				if (sym->u.segrel.segment != gSegment
					|| sym->u.segrel.offset != gAddress[gSegment])
					cerror("sync error");
				break;

			default:
				assert(0);
		}
	;
    break;}
case 9:
#line 256 "parse.y"
{
		EmitIns(yyvsp[0].id, NULL, mImplied, 0);
	;
    break;}
case 10:
#line 260 "parse.y"
{
		EmitImm(yyvsp[-2].id, &yyvsp[0].ivalue, FALSE);
	;
    break;}
case 11:
#line 264 "parse.y"
{
		EmitImm(yyvsp[-2].id, &yyvsp[0].ivalue, TRUE);
	;
    break;}
case 12:
#line 268 "parse.y"
{
		EmitIns(yyvsp[-1].id, &yyvsp[0].ivalue, mAbsolute, mZeroPage);
	;
    break;}
case 13:
#line 272 "parse.y"
{
		EmitIns(yyvsp[-3].id, &yyvsp[-1].ivalue, mIndirect, 0);
	;
    break;}
case 14:
#line 276 "parse.y"
{
		int	mode, zmode;

		if (yyvsp[0].id == NameID(gNames, "x") || yyvsp[0].id == NameID(gNames, "X"))
			mode = mAbsoluteX, zmode = mZeroPageX;
		else if (yyvsp[0].id == NameID(gNames, "y") || yyvsp[0].id == NameID(gNames, "Y"))
			mode = mAbsoluteY, zmode = mZeroPageY;
		else
		{
			uerror("bad addressing mode");
			mode = mAbsoluteX, zmode = mZeroPageX;
		}
		EmitIns(yyvsp[-3].id, &yyvsp[-2].ivalue, mode, zmode);
	;
    break;}
case 15:
#line 291 "parse.y"
{
		if (yyvsp[0].id != NameID(gNames, "y") && yyvsp[0].id != NameID(gNames, "Y"))
			uerror("bad addressing mode");
		else
			EmitIns(yyvsp[-5].id, &yyvsp[-3].ivalue, 0, mIndirectY);
	;
    break;}
case 16:
#line 298 "parse.y"
{
		if (yyvsp[-1].id != NameID(gNames, "x") && yyvsp[-1].id != NameID(gNames, "X"))
			uerror("bad addressing mode");
		else
			EmitIns(yyvsp[-5].id, &yyvsp[-3].ivalue, 0, mIndirectX);
	;
    break;}
case 17:
#line 307 "parse.y"
{ gAddress[gSegment] =
									RoundUp(gAddress[gSegment], yyvsp[0].intval); ;
    break;}
case 18:
#line 312 "parse.y"
{ gSegment = CodeSegment; ;
    break;}
case 19:
#line 313 "parse.y"
{ gSegment = DataSegment; ;
    break;}
case 20:
#line 314 "parse.y"
{ gSegment = BssSegment; ;
    break;}
case 21:
#line 318 "parse.y"
{ gHiBit = yyvsp[0].intval ? 0x80 : 0x00; ;
    break;}
case 22:
#line 319 "parse.y"
{ gExpand = yyvsp[0].intval ? TRUE : FALSE; ;
    break;}
case 23:
#line 323 "parse.y"
{ PsAscii(&yyvsp[0].textval, FALSE, FALSE); free(yyvsp[0].textval.chars); ;
    break;}
case 24:
#line 324 "parse.y"
{ PsAscii(&yyvsp[0].textval, TRUE, FALSE); free(yyvsp[0].textval.chars); ;
    break;}
case 25:
#line 325 "parse.y"
{ PsAscii(&yyvsp[0].textval, FALSE, TRUE); free(yyvsp[0].textval.chars); ;
    break;}
case 26:
#line 329 "parse.y"
{ PsData(&yyvsp[0].ivlist, 1, FALSE); ;
    break;}
case 27:
#line 330 "parse.y"
{ PsData(&yyvsp[0].ivlist, 2, FALSE); ;
    break;}
case 28:
#line 331 "parse.y"
{ PsData(&yyvsp[0].ivlist, 2, TRUE); ;
    break;}
case 29:
#line 332 "parse.y"
{ PsData(&yyvsp[0].ivlist, 4, FALSE); ;
    break;}
case 30:
#line 337 "parse.y"
{
		if (yyvsp[0].intval < 0 || yyvsp[0].intval > 0x8000)
			uerror("value out of range");
		gAddress[gSegment] += yyvsp[0].intval;
	;
    break;}
case 31:
#line 346 "parse.y"
{
		int		k;

		if (yyvsp[0].intval < 0 || yyvsp[0].intval > 0x8000)
			uerror("value out of range");
		for (k = 0; k < yyvsp[0].intval; k++)
			Emit(0);
	;
    break;}
case 32:
#line 358 "parse.y"
{ 
		int			k;
		List		list, next;
		Byte		value[FLOAT_SIZE_6502];

	/* Emit floats */

		for (list = &yyvsp[0].flist; list; list = list->next)
		{
			EncodeFloat(list->u.fvalue, value);
			for (k = 0; k < sizeof(value); k++)
				Emit(value[k]);
		}

	/* Free tail of list */

		for (list = yyvsp[0].flist.next; list; list = next)
		{
			next = list->next;
			free(list);
		}
	;
    break;}
case 33:
#line 384 "parse.y"
{
		Symbol	sym;
		List	list, next;

	/* Import symbols during pass one, verify during pass two */

		for (list = &yyvsp[0].idlist; list; list = list->next)
			switch (gPass)
			{
				case 1:
					Import(list->u.id);
					break;
				case 2:
					if ((sym = GetSym(list->u.id)))
						uerror("symbol \"%s\" defined locally",
							Name(gNames, list->u.id));
					break;
				default:
					assert(0);
			}

	/* Free tail of list */

		for (list = yyvsp[0].idlist.next; list; list = next)
		{
			next = list->next;
			free(list);
		}
	;
    break;}
case 34:
#line 414 "parse.y"
{
		Symbol	sym;
		List	list, next;

	/* Import symbols during pass one, verify during pass two */

		for (list = &yyvsp[0].idlist; list; list = list->next)
			switch (gPass)
			{
				case 1:
					ZpImport(list->u.id);
					break;
				case 2:
					if ((sym = GetSym(list->u.id)))
						uerror("symbol \"%s\" defined locally",
							Name(gNames, list->u.id));
					break;
				default:
					assert(0);
			}

	/* Free tail of list */

		for (list = yyvsp[0].idlist.next; list; list = next)
		{
			next = list->next;
			free(list);
		}
	;
    break;}
case 35:
#line 447 "parse.y"
{
		Symbol	sym;
		List	list, next;

	/* Export symbols during pass two */

		if (gPass == 2)
			for (list = &yyvsp[0].idlist; list; list = list->next)
				if ((sym = GetSym(list->u.id)))
					Export(sym);
				else
					uerror("undefined symbol \"%s\"",
						Name(gNames, list->u.id));

	/* Free tail of list */

		for (list = yyvsp[0].idlist.next; list; list = next)
		{
			next = list->next;
			free(list);
		}
	;
    break;}
case 36:
#line 472 "parse.y"
{ uerror("pseudo-op unimplemented"); ;
    break;}
case 37:
#line 473 "parse.y"
{ uerror("pseudo-op unimplemented"); ;
    break;}
case 38:
#line 474 "parse.y"
{ uerror("pseudo-op unimplemented"); ;
    break;}
case 39:
#line 475 "parse.y"
{ uerror("pseudo-op unimplemented"); ;
    break;}
case 40:
#line 476 "parse.y"
{ uerror("pseudo-op unimplemented"); ;
    break;}
case 41:
#line 477 "parse.y"
{ uerror("pseudo-op unimplemented"); ;
    break;}
case 42:
#line 478 "parse.y"
{ uerror("pseudo-op unimplemented"); ;
    break;}
case 43:
#line 485 "parse.y"
{
		yyval.idlist.u.id = yyvsp[0].id;
		yyval.idlist.next = NULL;
	;
    break;}
case 44:
#line 490 "parse.y"
{
		yyval.idlist.u.id = yyvsp[-2].id;
		yyval.idlist.next = NewOpaque(List);
		yyval.idlist.next->u.id = yyvsp[0].idlist.u.id;
	 	yyval.idlist.next->next = yyvsp[0].idlist.next;
	;
    break;}
case 45:
#line 500 "parse.y"
{
		yyval.ivlist.u.ivalue = yyvsp[0].ivalue;
		yyval.ivlist.next = NULL;
	;
    break;}
case 46:
#line 505 "parse.y"
{
		yyval.ivlist.u.ivalue = yyvsp[-2].ivalue;
		yyval.ivlist.next = NewOpaque(List);
		yyval.ivlist.next->u.ivalue = yyvsp[0].ivlist.u.ivalue;
		yyval.ivlist.next->next = yyvsp[0].ivlist.next;
	;
    break;}
case 47:
#line 515 "parse.y"
{
		yyval.flist.u.fvalue = yyvsp[0].floatval;
		yyval.flist.next = NULL;
	;
    break;}
case 48:
#line 520 "parse.y"
{
		yyval.flist.u.fvalue = yyvsp[-2].floatval;
		yyval.flist.next = NewOpaque(List);
		yyval.flist.next->u.fvalue = yyvsp[0].flist.u.fvalue;
		yyval.flist.next->next = yyvsp[0].flist.next;
	;
    break;}
case 49:
#line 530 "parse.y"
{
		yyval.ivalue.type = iSegRel;
		yyval.ivalue.u.segrel.segment = AbsSegment;
		yyval.ivalue.u.segrel.offset = yyvsp[0].intval;
	;
    break;}
case 50:
#line 536 "parse.y"
{
		yyval.ivalue = yyvsp[-1].ivalue;
	;
    break;}
case 51:
#line 540 "parse.y"
{
		yyval.ivalue = yyvsp[-4].intval ? yyvsp[-2].ivalue : yyvsp[0].ivalue;
	;
    break;}
case 52:
#line 544 "parse.y"
{
		yyval.ivalue.type = iSegRel;
		yyval.ivalue.u.segrel.segment = gSegment;
		yyval.ivalue.u.segrel.offset = gAddress[gSegment];
	;
    break;}
case 53:
#line 550 "parse.y"
{
		Symbol	sym = GetSym(yyvsp[0].id);

		switch (gPass)
		{
			case 1:
				if (sym)
					switch (sym->type)
					{
						case sSegRel:
							yyval.ivalue.type = iSegRel;
							yyval.ivalue.u.segrel = sym->u.segrel;
							break;
						case sSymOff:
							yyval.ivalue.type = iSymOff;
							yyval.ivalue.u.symoff = sym->u.symoff;
							break;
						default:
							assert(0);
					}
				else
					if (IsZpImport(yyvsp[0].id))
					{
						yyval.ivalue.type = iSymOff;
						yyval.ivalue.u.symoff.id = yyvsp[0].id;
						yyval.ivalue.u.symoff.offset = 0;
					}
					else
						yyval.ivalue.type = iUnknown;
				break;

			case 2:
				if (sym)
					if (!sym->valid)
					{
						uerror("illegal forward reference to \"%s\"",
							Name(gNames, sym->id));
						yyval.ivalue.type = iSegRel;
						yyval.ivalue.u.segrel.segment = AbsSegment;
						yyval.ivalue.u.segrel.offset = 0;
					}
					else
						switch (sym->type)
						{
							case sSegRel:
								yyval.ivalue.type = iSegRel;
								yyval.ivalue.u.segrel = sym->u.segrel;
								break;
							case sSymOff:
								yyval.ivalue.type = iSymOff;
								yyval.ivalue.u.symoff = sym->u.symoff;
								break;
							default:
								assert(0);
						}
				else
				{
					yyval.ivalue.type = iSymOff;
					yyval.ivalue.u.symoff.id = yyvsp[0].id;
					yyval.ivalue.u.symoff.offset = 0;
				}
				break;

			default:
				assert(0);
		}
	;
    break;}
case 54:
#line 619 "parse.y"
{
		if (yyvsp[-2].ivalue.type == iUnknown || yyvsp[0].ivalue.type == iUnknown)
			yyval.ivalue.type = iUnknown;
		else
			switch (yyvsp[-2].ivalue.type)
			{
				case iSegRel:
					switch (yyvsp[0].ivalue.type)
					{
						case iSegRel:
							yyval.ivalue.type = iSegRel;
							if (yyvsp[-2].ivalue.u.segrel.segment == AbsSegment)
								yyval.ivalue = yyvsp[0].ivalue;
							else if (yyvsp[0].ivalue.u.segrel.segment == AbsSegment)
								yyval.ivalue = yyvsp[-2].ivalue;
							else
								uerror("illegal expression");
							yyval.ivalue.u.segrel.offset =
								yyvsp[-2].ivalue.u.segrel.offset + yyvsp[0].ivalue.u.segrel.offset;
							break;
						case iSymOff:
							if (yyvsp[-2].ivalue.u.segrel.segment != AbsSegment)
								uerror("illegal unresolved expression");
							yyval.ivalue = yyvsp[0].ivalue;
							yyval.ivalue.u.symoff.offset += yyvsp[-2].ivalue.u.segrel.offset;
							break;
						default:
							assert(0);
					}
					break;
				case iSymOff:
					switch (yyvsp[0].ivalue.type)
					{
						case iSegRel:
							if (yyvsp[0].ivalue.u.segrel.segment != AbsSegment)
								uerror("illegal unresolved expression");
							yyval.ivalue = yyvsp[-2].ivalue;
							yyval.ivalue.u.symoff.offset += yyvsp[0].ivalue.u.segrel.offset;
							break;
						case iSymOff:
							uerror("illegal unresolved expression");
							break;
					}
					break;
				default:
					assert(0);
			}
	;
    break;}
case 55:
#line 669 "parse.y"
{
		if (yyvsp[-2].ivalue.type == iUnknown || yyvsp[0].ivalue.type == iUnknown)
			yyval.ivalue.type = iUnknown;
		else
			switch (yyvsp[0].ivalue.type)
			{
				case iSegRel:
					switch (yyvsp[-2].ivalue.type)
					{
						case iSegRel:
							if (yyvsp[-2].ivalue.u.segrel.segment == yyvsp[0].ivalue.u.segrel.segment)
							{
								yyval.ivalue.type = iSegRel;
								yyval.ivalue.u.segrel.segment = AbsSegment;
								yyval.ivalue.u.segrel.offset =
									yyvsp[-2].ivalue.u.segrel.offset - yyvsp[0].ivalue.u.segrel.offset;
							}
							else
							{
								if (yyvsp[0].ivalue.u.segrel.segment != AbsSegment)
									uerror("illegal expression");
								yyval.ivalue = yyvsp[-2].ivalue;
								yyval.ivalue.u.segrel.offset -= yyvsp[0].ivalue.u.segrel.offset;
							}
							break;
						case iSymOff:
							if (yyvsp[0].ivalue.u.segrel.segment != AbsSegment)
								uerror("illegal expression");
							yyval.ivalue = yyvsp[-2].ivalue;
							yyval.ivalue.u.symoff.offset -= yyvsp[0].ivalue.u.segrel.offset;
							break;
						default:
							assert(0);
					}
					break;
				case iSymOff:
					if (yyvsp[-2].ivalue.type != iSymOff || yyvsp[-2].ivalue.u.symoff.id != yyvsp[0].ivalue.u.symoff.id)
						uerror("illegal expression");
					yyval.ivalue.type = iSegRel;
					yyval.ivalue.u.segrel.segment = AbsSegment;
					yyval.ivalue.u.segrel.offset =
						yyvsp[-2].ivalue.u.symoff.offset - yyvsp[0].ivalue.u.symoff.offset;
					break;
				default:
					assert(0);
			}
	;
    break;}
case 56:
#line 716 "parse.y"
{ UnaryOp(yyvsp[0].ivalue,yyval.ivalue,+); ;
    break;}
case 57:
#line 717 "parse.y"
{ UnaryOp(yyvsp[0].ivalue,yyval.ivalue,-); ;
    break;}
case 58:
#line 718 "parse.y"
{ UnaryOp(yyvsp[0].ivalue,yyval.ivalue,!); ;
    break;}
case 59:
#line 719 "parse.y"
{ UnaryOp(yyvsp[0].ivalue,yyval.ivalue,~); ;
    break;}
case 60:
#line 720 "parse.y"
{ BinaryOp(yyvsp[-2].ivalue,yyvsp[0].ivalue,yyval.ivalue,*); ;
    break;}
case 61:
#line 721 "parse.y"
{ BinaryOp(yyvsp[-2].ivalue,yyvsp[0].ivalue,yyval.ivalue,/); ;
    break;}
case 62:
#line 722 "parse.y"
{ BinaryOp(yyvsp[-2].ivalue,yyvsp[0].ivalue,yyval.ivalue,%); ;
    break;}
case 63:
#line 723 "parse.y"
{ BinaryOp(yyvsp[-2].ivalue,yyvsp[0].ivalue,yyval.ivalue,<<); ;
    break;}
case 64:
#line 724 "parse.y"
{ BinaryOp(yyvsp[-2].ivalue,yyvsp[0].ivalue,yyval.ivalue,>>); ;
    break;}
case 65:
#line 725 "parse.y"
{ BinaryOp(yyvsp[-2].ivalue,yyvsp[0].ivalue,yyval.ivalue,&&); ;
    break;}
case 66:
#line 726 "parse.y"
{ BinaryOp(yyvsp[-2].ivalue,yyvsp[0].ivalue,yyval.ivalue,||); ;
    break;}
case 67:
#line 727 "parse.y"
{ BinaryOp(yyvsp[-2].ivalue,yyvsp[0].ivalue,yyval.ivalue,&); ;
    break;}
case 68:
#line 728 "parse.y"
{ BinaryOp(yyvsp[-2].ivalue,yyvsp[0].ivalue,yyval.ivalue,^); ;
    break;}
case 69:
#line 729 "parse.y"
{ BinaryOp(yyvsp[-2].ivalue,yyvsp[0].ivalue,yyval.ivalue,|); ;
    break;}
case 70:
#line 730 "parse.y"
{ BinaryOp(yyvsp[-2].ivalue,yyvsp[0].ivalue,yyval.ivalue,==); ;
    break;}
case 71:
#line 731 "parse.y"
{ BinaryOp(yyvsp[-2].ivalue,yyvsp[0].ivalue,yyval.ivalue,!=); ;
    break;}
case 72:
#line 732 "parse.y"
{ BinaryOp(yyvsp[-2].ivalue,yyvsp[0].ivalue,yyval.ivalue,<); ;
    break;}
case 73:
#line 733 "parse.y"
{ BinaryOp(yyvsp[-2].ivalue,yyvsp[0].ivalue,yyval.ivalue,<=); ;
    break;}
case 74:
#line 734 "parse.y"
{ BinaryOp(yyvsp[-2].ivalue,yyvsp[0].ivalue,yyval.ivalue,>); ;
    break;}
case 75:
#line 735 "parse.y"
{ BinaryOp(yyvsp[-2].ivalue,yyvsp[0].ivalue,yyval.ivalue,>=); ;
    break;}
case 76:
#line 739 "parse.y"
{ yyval.intval = yyvsp[0].intval; ;
    break;}
case 77:
#line 740 "parse.y"
{ yyval.intval = yyvsp[0].charval; ;
    break;}
case 78:
#line 745 "parse.y"
{
		if (yyvsp[0].ivalue.type != iSegRel || yyvsp[0].ivalue.u.segrel.segment != AbsSegment)
			uerror("illegal floating point expression");
		yyval.floatval = (double) yyvsp[0].ivalue.u.segrel.offset;
	;
    break;}
case 79:
#line 750 "parse.y"
{ yyval.floatval = yyvsp[0].floatval; ;
    break;}
case 80:
#line 751 "parse.y"
{ yyval.floatval = yyvsp[0].floatval; ;
    break;}
case 81:
#line 752 "parse.y"
{ yyval.floatval = -yyvsp[0].floatval; ;
    break;}
case 83:
#line 758 "parse.y"
{
		yyval.textval.chars = GetMem(yyval.textval.len = yyvsp[-1].textval.len + yyvsp[0].textval.len);
		memcpy(yyval.textval.chars, yyvsp[-1].textval.chars, yyvsp[-1].textval.len);
		memcpy(yyval.textval.chars + yyvsp[-1].textval.len, yyvsp[0].textval.chars, yyvsp[0].textval.len);
		free(yyvsp[-1].textval.chars);
		free(yyvsp[0].textval.chars);
	;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 465 "/usr/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 767 "parse.y"
