typedef union
	{
		unsigned		id;				/* Identifier */
		int				intval;			/* Integer literal */
		double			floatval;		/* Floating point literal */
		char			charval;		/* Character literal */
		struct TValue	textval;		/* String literal */
		struct IValue	ivalue;			/* Ivalue */
		struct List		ivlist;			/* List of ivalues */
		struct List		idlist;			/* List of identifiers */
		struct List		flist;			/* List of floats */
	} YYSTYPE;
#define	LOR	258
#define	LAND	259
#define	EQU	260
#define	NEQ	261
#define	LE	262
#define	GE	263
#define	LSH	264
#define	RSH	265
#define	LSB	266
#define	MSB	267
#define	ALIGN	268
#define	ASCII	269
#define	ASCIZ	270
#define	BEGNN	271
#define	BSS	272
#define	BYTE	273
#define	CODE	274
#define	DATA	275
#define	DBYT	276
#define	DCI	277
#define	ELSE	278
#define	END	279
#define	ENDIF	280
#define	ENDM	281
#define	IF	282
#define	EXPAND	283
#define	FLOAT	284
#define	GLOBAL	285
#define	HIBIT	286
#define	MACRO	287
#define	LONG	288
#define	SPACE	289
#define	WORD	290
#define	ZERO	291
#define	IMPORT	292
#define	ZIMPORT	293
#define	INTLIT	294
#define	FLOATLIT	295
#define	CHARLIT	296
#define	TEXTLIT	297
#define	LABEL	298
#define	IDENT	299


extern YYSTYPE yylval;
